﻿define(['services/logger', 'durandal/system'],
function ( logger, system) {
    var northwind = [
        {
            "EmployeeID": 1,
            "LastName": "Davolio",
            "FirstName": "Nancy",
            "HomePhone": "(206) 555-9857",
            "Orders": [{
                "OrderID": 10258,
                "CustomerID": "ERNSH",
                "Freight": "140.5100",
                "ShipName": "Ernst Handel",
                "ShipAddress": "Kirchgasse 6",
                "ShipCity": "Graz",
                "ShipCountry": "Austria"
            },
            {
                "OrderID": 10270,
                "CustomerID": "WARTH",
                "Freight": "136.5400",
                "ShipName": "Wartian Herkku",
                "ShipAddress": "Torikatu 38",
                "ShipCity": "Oulu",
                "ShipCountry": "Finland",
            }
        ]
        }
    ];
  
			

    var isAttachedToView = ko.observable(false);
    // var ctdItems = ko.observableArray([]);
    var ctdItems = [];
    var ctdItemsString = '';
    var deferred = $.Deferred();
    var deferred1 = $.Deferred();
    var initialized = false;
    var ctd = {
        activate: activate,
        ctdItems: ctdItems,
        northwind: northwind,
        ctdItemsString: ctdItemsString,
        refresh: refresh,
        isAttachedToView: isAttachedToView,
        viewAttached: function (view) {
            setIsAttachedToView();
            loadGrid(view);
        },
        title: 'CTD'
    };
    return ctd;
    function loadGrid(view) {
        return $.ig.loader(function () {
            $("#grid1").igHierarchicalGrid({
                features: [
                {
                    name: "Paging",
                    type: "local",
                    pageSize: 4
                },
                {
                    name: "Sorting"
                },
                {
                    name: "Filtering"
                },
                {
                    name: "Updating"
                },
                {
                    name: "Resizing",
                    allowDoubleClickToResize: true
                },
                {
                    name: "Tooltips",
                    visibility: "always"
                },
                {
                    name: "Hiding"
                },
                {
                    name: "Summaries"
                },
                {
                    name: "Selection"
                },
                {
                    name: "RowSelectors"
                },
                {
                    name: "GroupBy"
                },
                {
                    name: "MultiColumnHeaders"
                },
                {
                    name: "ColumnMoving"
                },
                {
                    name: "CellMerging",
                    initialState: "merged"
                }
                ],

                initialDataBindDepth: -1,
                dataSource: northwind,
                dataSourceType: "json",
                responseDataKey: 'results',
                width: "700px",

                autoGenerateColumns: false,
                primaryKey: "EmployeeID",
                columns: [
                    { key: "EmployeeID", headerText: "Employee ID", dataType: "number", width: "100px" },
                    {
                        headerText: "Employee Details",
                        group: [
                            { key: "LastName", headerText: "Last Name", dataType: "string", width: "150px" },
                            { key: "FirstName", headerText: "First Name", dataType: "string", width: "150px" },
                            { key: "HomePhone", headerText: "Home Phone", dataType: "string", width: "150px" }
                        ]
                    }
                ],
                childrenDataProperty: "Orders",
                autoGenerateLayouts: false,
                columnLayouts: [
                {
                    key: "Orders",
                    responseDataKey: 'results',
                    autoGenerateColumns: false,
                    primaryKey: "OrderID",
                    columns: [
                        { key: "OrderID", headerText: "Order ID", dataType: "number", width: "50px" },
                        { key: "CustomerID", headerText: "Customer ID", dataType: "string", width: "60px" },
                        { key: "Freight", headerText: "Freight", dataType: "string", width: "70px" },
                            {
                                headerText: "Ship Details",
                                group: [
                                    { key: "ShipName", headerText: "Ship Name", dataType: "string", width: "100px" },
                                    { key: "ShipAddress", headerText: "Ship Address", dataType: "string", width: "90px" },
                                    { key: "ShipCity", headerText: "Ship City", dataType: "string", width: "90px" },
                                    { key: "ShipCountry", headerText: "Ship Country", dataType: "string", width: "80px" }
                                ]
                            }
                    ],
                    features: [
                    {
                        name: "Paging",
                        type: "local",
                        pageSize: 10
                    },
                    {
                        name: "Sorting"
                    },
                    {
                        name: "Filtering"
                    },
                    {
                        name: "Updating"
                    },
                    {
                        name: "Resizing",
                        allowDoubleClickToResize: true
                    },
                    {
                        name: "Tooltips",
                        visibility: "always"
                    },
                    {
                        name: "Hiding"
                    },
                    {
                        name: "Summaries"
                    },
                    {
                        name: "RowSelectors"
                    },
                    {
                        name: "GroupBy"
                    },
                    {
                        name: "MultiColumnHeaders"
                    },
                    {
                        name: "ColumnMoving"
                    },
                    {
                        name: "CellMerging",
                        initialState: "merged"
                    }
                    ]
                }]
            });
        });

    }
    function setIsAttachedToView() {
        isAttachedToView(true);
    }
    function activate() {
        if (initialized) { return; }
        initialized = true;
        refresh();

        return deferred.promise();
    }

    function refresh() {
        $.ig.loader({
            scriptPath: "http://cdn-na.infragistics.com/jquery/20131/latest/js/",
            cssPath: "http://cdn-na.infragistics.com/jquery/20131/latest/css/",
            resources: "igHierarchicalGrid.*",
            ready: function () {
                deferred.resolve();
            }
        });
    }
});

