﻿define(['durandal/system'], function (system) {
    var isAttachedToView = ko.observable(false);
    var deferred = $.Deferred();
    var ctdHeaderItems = [{ "$id": "1", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "FutureCode", "headerText": "Future Code", "width": "80", "dataType": "string", "format": null }, { "$id": "2", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "Ccode", "headerText": "Bond Future", "width": "170", "dataType": "string", "format": null }, { "$id": "3", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "FuturePrice", "headerText": "Future Price", "width": "80", "dataType": "number", "format": null }, { "$id": "4", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "MarketRepoRate", "headerText": "Market Repo Rate", "width": "120", "dataType": "number", "format": null }, { "$id": "5", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "ISIN", "headerText": "ISIN", "width": "120", "dataType": "string", "format": null }, { "$id": "6", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "Coupon", "headerText": "Coupon", "width": "60", "dataType": "string", "format": null }, { "$id": "7", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "Maturity", "headerText": "Maturity", "width": "80", "dataType": "date", "format": "MMM/dd/yy" }, { "$id": "8", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "CleanPrice", "headerText": "Clean Price", "width": "80", "dataType": "number", "format": null }, { "$id": "9", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "ConversionFactore", "headerText": "Conversion Factor", "width": "80", "dataType": "number", "format": null }, { "$id": "10", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "ImpliedRepoRate", "headerText": "Implied Repo Rate", "width": "80", "dataType": "number", "format": null }, { "$id": "11", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "MarketRepoNetBasis", "headerText": "Market Repo NetBasis", "width": "80", "dataType": "number", "format": null }, { "$id": "12", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "CheapestToDeliver", "headerText": "Cheapest To Deliver", "width": "120", "dataType": "string", "format": null }, { "$id": "13", "$type": "Razor.model.BusinessObjects.GridAttribute, Razor.core", "key": "asOfTime", "headerText": "Time", "width": "120", "dataType": "string", "format": null }];
    var settings = {
        activate: activate,
        title: 'Settings',
        ctdHeaderItems: ctdHeaderItems,
        viewAttached: function (view) {            
            setIsAttachedToView();
            loadGrid(view);
        },
        isAttachedToView: isAttachedToView
    };
    function setIsAttachedToView() {
        isAttachedToView(true);
    }
    return settings;   

    function activate(data) {
        
        $.ig.loader({
            scriptPath: "../Scripts/Infragistics/js/",
            cssPath: "../Content/Infragistics/css/",
            theme: "infragistics",
            resources: "igGrid.Updating.Selection,extensions/infragistics.datasource.knockoutjs.js,extensions/infragistics.ui.grid.knockout-extensions.js",
            ready: function () {
                return deferred.resolve();
            }
        });
       // logger.log("Razor 2013 settings page loaded", null, system.getModuleId(settings), true);
        return deferred.promise();
    }

    function loadGrid(view) {
        var settingsForm = $(view).find('#grid_settings');
        $.ig.loader(function () {
            settingsForm.igGrid({
                dataSource: ctdHeaderItems,
                autoGenerateColumns: true,
                primaryKey: 'key',
                features: [

                    {
                        name: 'Updating',
                        enableDataDirtyException: false,
                        editMode: 'rowedittemplate',
                        startEditTriggers: "dblclick",
                        showReadonlyEditors: false,  // any field set to "readOnly: true" below will show up in edit mode.                 
                        rowEditDialogWidth: 400,
                        rowEditDialogRowTemplate: "<tr>" +
                            "<td>${headerText}</td><td data-key=\'${dataKey}\'><input /></td>" + "</tr>",
                        //'<td data-key=\'${dataKey}\'>{{if /${headerText} ==\'OnSite\'}}<input type=\'checkbox\' />{{else}}<input />{{/if}}</td>' +
                        //'</tr>',
                        columnSettings: [
                            {
                                columnKey: "key",
                                readOnly: true,
                            },
                            { columnKey: "headerText" },
                            {
                                columnKey: "width",
                                editorType: "numeric",
                                validation: true,
                                editorOptions: { button: 'spin', required: true }
                            },
                            {
                                columnKey: "format"
                            },
                            {
                                columnKey: "hidden"
                            }
                        ]

                    }]
            });
        });

    }
            
});