using System;
using System.Web.Optimization;

namespace MvcApplication1
{
    public class BundleConfig
    {
        public static void RegisterBundles(BundleCollection bundles)
        {
            bundles.IgnoreList.Clear();
            AddDefaultIgnorePatterns(bundles.IgnoreList);

            bundles.Add(
              new ScriptBundle("~/scripts/vendor")
                .Include("~/Scripts/jquery-{version}.js")
                .Include("~/Scripts/jquery-ui-{version}.js")
                .Include("~/Scripts/knockout-{version}.debug.js")
                .Include("~/Scripts/sammy-{version}.js")
                .Include("~/Scripts/toastr.js")
                .Include("~/Scripts/Q.js")
                .Include("~/Scripts/Infragistics/js/infragistics.core.js")
                .Include("~/Scripts/Infragistics/js/infragistics.lob.js")
                .Include("~/Scripts/Infragistics/js/infragistics.dv.js")
                .Include("~/Scripts/Infragistics/js/infragistics.loader.js")
                .Include("~/Scripts/breeze.debug.js")
                .Include("~/Scripts/bootstrap.js")
                .Include("~/Scripts/moment.js")
              );

            bundles.Add(
              new StyleBundle("~/Content/css")
                .Include("~/Content/ie10mobile.css")
                .Include("~/Content/bootstrap.css")
                .Include("~/Content/bootstrap-responsive.css")
                .Include("~/Content/durandal.css")
                .Include("~/Content/toastr.css")
                .Include("~/Content/app.css")
                .Include("~/Content/Infragistics/css/themes/infragistics/infragistics.theme.css")
                .Include("~/Content/Infragistics/css/structure/infragistics.css")
              );
        }

        public static void AddDefaultIgnorePatterns(IgnoreList ignoreList)
        {
            if (ignoreList == null)
            {
                throw new ArgumentNullException("ignoreList");
            }

            ignoreList.Ignore("*.intellisense.js");
            ignoreList.Ignore("*-vsdoc.js");

            //ignoreList.Ignore("*.debug.js", OptimizationMode.WhenEnabled);
            //ignoreList.Ignore("*.min.js", OptimizationMode.WhenDisabled);
            //ignoreList.Ignore("*.min.css", OptimizationMode.WhenDisabled);
        }
    }
}